/*
Copyright (c) 2000,2001. The Regents of the University of California
(Regents). All Rights Reserved. 

Permission to use, copy, modify, and distribute this software and its
documentation for educational, research, and not-for-profit purposes,
without fee and without a signed licensing agreement, is hereby
granted, provided that the above copyright notice, this paragraph and
the following two paragraphs appear in all copies, modifications, and
distributions. Contact The Office of Technology Licensing, UC
Berkeley, 2150 Shattuck Avenue, Suite 510, Berkeley, CA 94720-1620,
(510) 643-7201, for commercial licensing opportunities.
  
IN NO EVENT SHALL REGENTS BE LIABLE TO ANY PARTY FOR DIRECT,
INDIRECT, SPECIAL, INCIDENTAL, OR CONSEQUENTIAL DAMAGES, INCLUDING
LOST PROFITS, ARISING OUT OF THE USE OF THIS SOFTWARE AND ITS
DOCUMENTATION, EVEN IF REGENTS HAS BEEN ADVISED OF THE POSSIBILITY OF
SUCH DAMAGE. 
  
REGENTS SPECIFICALLY DISCLAIMS ANY WARRANTIES, INCLUDING, BUT NOT
LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR
A PARTICULAR PURPOSE. THE SOFTWARE AND ACCOMPANYING DOCUMENTATION, IF
ANY, PROVIDED HEREUNDER IS PROVIDED "AS IS". REGENTS HAS NO
OBLIGATION TO PROVIDE MAINTENANCE, SUPPORT, UPDATES, ENHANCEMENTS, OR
MODIFICATIONS.
*/
				 
package orthotweezers;

import java.text.NumberFormat;
import java.awt.*;

/** Modeless dialog window for monitoring the orthotweezers system.
 *
 * @author  unknown
 */
public class OrthoTweezersMonitor extends javax.swing.JDialog {

    /** Creates new form OrthoTweezersMonitor as a modeless dialog
     *
     * @param parent    the parent Frame
     * @param control   the OrthoTweezersControl created by the main window
     *                  which is queried for the values to display.
     */
    public OrthoTweezersMonitor(java.awt.Frame parent, OrthoTweezersControl control) {
        super (parent, false);
        _control = control;
        initComponents ();
    }

    /** This method is called from within the constructor to
     * initialize the form.
     * WARNING: Do NOT modify this code. The content of this method is
     * always regenerated by the FormEditor.
     */
    private void initComponents() {//GEN-BEGIN:initComponents
        monitorTimer = new org.netbeans.examples.lib.timerbean.Timer();
        jLabel1 = new javax.swing.JLabel();
        jLabel2 = new javax.swing.JLabel();
        jLabel3 = new javax.swing.JLabel();
        jLabel4 = new javax.swing.JLabel();
        _xArmDeflectionLabel = new javax.swing.JLabel();
        _yArmDeflectionLabel = new javax.swing.JLabel();
        _xTipForceLabel = new javax.swing.JLabel();
        _yTipForceLabel = new javax.swing.JLabel();
        jLabel5 = new javax.swing.JLabel();
        jLabel6 = new javax.swing.JLabel();
        jLabel7 = new javax.swing.JLabel();
        _stageX = new javax.swing.JLabel();
        _stageY = new javax.swing.JLabel();
        _stageZ = new javax.swing.JLabel();
        jLabel8 = new javax.swing.JLabel();
        _xTipDeflectionLabel = new javax.swing.JLabel();
        _yTipDeflectionLabel = new javax.swing.JLabel();
        _probesCanvas = new ProbesCanvas(this);
        monitorTimer.setDelay(100L);
        monitorTimer.addTimerListener(new org.netbeans.examples.lib.timerbean.TimerListener() {
            public void onTime(java.awt.event.ActionEvent evt) {
                monitorTimerOnTime(evt);
            }
        }
        );
        getContentPane().setLayout(null);
        setTitle("Ortho Tweezers Monitor");
        addWindowListener(new java.awt.event.WindowAdapter() {
            public void windowClosing(java.awt.event.WindowEvent evt) {
                closeDialog(evt);
            }
        }
        );
        
        jLabel1.setText("Arm Deflection (mm)");
        
        getContentPane().add(jLabel1);
        jLabel1.setBounds(0, 20, 120, 20);
        
        
        jLabel2.setText("Tip Force (mN)");
        
        getContentPane().add(jLabel2);
        jLabel2.setBounds(0, 60, 120, 20);
        
        
        jLabel3.setText("Probe X");
        
        getContentPane().add(jLabel3);
        jLabel3.setBounds(130, 0, 60, 20);
        
        
        jLabel4.setText("Probe Y");
        
        getContentPane().add(jLabel4);
        jLabel4.setBounds(220, 0, 50, 20);
        
        
        _xArmDeflectionLabel.setBorder(new javax.swing.border.LineBorder(java.awt.Color.black));
        _xArmDeflectionLabel.setText("...");
        
        getContentPane().add(_xArmDeflectionLabel);
        _xArmDeflectionLabel.setBounds(120, 20, 80, 20);
        
        
        _yArmDeflectionLabel.setBorder(new javax.swing.border.LineBorder(java.awt.Color.black));
        _yArmDeflectionLabel.setText("...");
        
        getContentPane().add(_yArmDeflectionLabel);
        _yArmDeflectionLabel.setBounds(200, 20, 80, 20);
        
        
        _xTipForceLabel.setBorder(new javax.swing.border.LineBorder(java.awt.Color.black));
        _xTipForceLabel.setText("...");
        
        getContentPane().add(_xTipForceLabel);
        _xTipForceLabel.setBounds(120, 60, 80, 20);
        
        
        _yTipForceLabel.setBorder(new javax.swing.border.LineBorder(java.awt.Color.black));
        _yTipForceLabel.setText("...");
        
        getContentPane().add(_yTipForceLabel);
        _yTipForceLabel.setBounds(200, 60, 80, 20);
        
        
        jLabel5.setText("stage X (mm)");
        
        getContentPane().add(jLabel5);
        jLabel5.setBounds(30, 90, 80, 20);
        
        
        jLabel6.setText("stage Y (mm)");
        
        getContentPane().add(jLabel6);
        jLabel6.setBounds(30, 110, 80, 20);
        
        
        jLabel7.setText("stage Z (mm)");
        
        getContentPane().add(jLabel7);
        jLabel7.setBounds(30, 130, 80, 20);
        
        
        _stageX.setBorder(new javax.swing.border.LineBorder(java.awt.Color.black));
        _stageX.setText("...");
        
        getContentPane().add(_stageX);
        _stageX.setBounds(110, 90, 80, 20);
        
        
        _stageY.setBorder(new javax.swing.border.LineBorder(java.awt.Color.black));
        _stageY.setText("...");
        
        getContentPane().add(_stageY);
        _stageY.setBounds(110, 110, 80, 20);
        
        
        _stageZ.setBorder(new javax.swing.border.LineBorder(java.awt.Color.black));
        _stageZ.setText("...");
        
        getContentPane().add(_stageZ);
        _stageZ.setBounds(110, 130, 80, 20);
        
        
        jLabel8.setText("Tip Deflection (mm)");
        
        getContentPane().add(jLabel8);
        jLabel8.setBounds(0, 40, 120, 20);
        
        
        _xTipDeflectionLabel.setBorder(new javax.swing.border.LineBorder(java.awt.Color.black));
        _xTipDeflectionLabel.setText("...");
        
        getContentPane().add(_xTipDeflectionLabel);
        _xTipDeflectionLabel.setBounds(120, 40, 80, 20);
        
        
        _yTipDeflectionLabel.setBorder(new javax.swing.border.LineBorder(java.awt.Color.black));
        _yTipDeflectionLabel.setText("...");
        
        getContentPane().add(_yTipDeflectionLabel);
        _yTipDeflectionLabel.setBounds(200, 40, 80, 20);
        
        
        _probesCanvas.setBackground(java.awt.Color.white);
        
        getContentPane().add(_probesCanvas);
        _probesCanvas.setBounds(110, 160, 120, 120);
        
        setBounds(360, 20, 300, 320);
    }//GEN-END:initComponents

  private void monitorTimerOnTime (java.awt.event.ActionEvent evt) {//GEN-FIRST:event_monitorTimerOnTime
// Add your handling code here:
    NumberFormat nf = NumberFormat.getInstance();
    nf.setMinimumFractionDigits (4);
    nf.setMaximumFractionDigits (4);
    
    // This reads the probe X and Y tip strain gauges twice, but do it anyway.
    // Get local copies of the forces and deflections which will be used by the
    //   numeric label displays and the canvas
    // Read the tip strains only once and convert to deflections and forces.
    double xTipStrain = _control.xTipStrain();
    double yTipStrain = _control.yTipStrain();
    _xTipDeflection = xTipStrain * _control.strainToDeflectionXTip();
    _xTipForce = xTipStrain * _control.strainToForceXTip();
    _yTipDeflection = yTipStrain * _control.strainToDeflectionYTip();
    _yTipForce = yTipStrain * _control.strainToForceYTip();
    _xArmDeflection = _control.xArmDeflection();
    _yArmDeflection = _control.yArmDeflection();
    
    // Now set the numeric label display
    _xArmDeflectionLabel.setText (nf.format (_xArmDeflection));
    _yArmDeflectionLabel.setText (nf.format (_yArmDeflection));
    _xTipDeflectionLabel.setText (nf.format (_xTipDeflection));
    _yTipDeflectionLabel.setText (nf.format (_yTipDeflection));
    _xTipForceLabel.setText (nf.format (_xTipForce));
    _yTipForceLabel.setText (nf.format (_yTipForce));
    _stageX.setText (nf.format (_control.stageX()));
    _stageY.setText (nf.format (_control.stageY()));
    _stageZ.setText (nf.format (_control.stageZ()));
    
    // Redraw the probes position canvas
    _probesCanvas.repaint();
  }//GEN-LAST:event_monitorTimerOnTime

    /** Closes the dialog */
    private void closeDialog(java.awt.event.WindowEvent evt) {//GEN-FIRST:event_closeDialog
        // Make sure we stop the timer so it stops querying the D/A
        monitorTimer.stop();
        setVisible (false);
        dispose ();
    }//GEN-LAST:event_closeDialog

    // Variables declaration - do not modify//GEN-BEGIN:variables
    private org.netbeans.examples.lib.timerbean.Timer monitorTimer;
    private javax.swing.JLabel jLabel1;
    private javax.swing.JLabel jLabel2;
    private javax.swing.JLabel jLabel3;
    private javax.swing.JLabel jLabel4;
    private javax.swing.JLabel _xArmDeflectionLabel;
    private javax.swing.JLabel _yArmDeflectionLabel;
    private javax.swing.JLabel _xTipForceLabel;
    private javax.swing.JLabel _yTipForceLabel;
    private javax.swing.JLabel jLabel5;
    private javax.swing.JLabel jLabel6;
    private javax.swing.JLabel jLabel7;
    private javax.swing.JLabel _stageX;
    private javax.swing.JLabel _stageY;
    private javax.swing.JLabel _stageZ;
    private javax.swing.JLabel jLabel8;
    private javax.swing.JLabel _xTipDeflectionLabel;
    private javax.swing.JLabel _yTipDeflectionLabel;
    private java.awt.Canvas _probesCanvas;
    // End of variables declaration//GEN-END:variables

    private OrthoTweezersControl _control;
    double _xTipDeflection, _xTipForce, _xArmDeflection;
    double _yTipDeflection, _yTipForce, _yArmDeflection;
}

/** A ProbesCanvas is used to draw the probe positions on the _probesCanvas.
 * It is created by the automatic code generator for the Canvas because the
 * Code Generation property was changed to say new ProbesCanvas(this);
 * Otherwise, the ProbesCanvas is treated as a normal Canvas by calling
 * its repaint(), etc.
 */
class ProbesCanvas extends Canvas {
    /** Creates a new ProbesCanvas and calls super() for the base Canvas.
     *
     * @param monitor   the parent OrthoTweezersMonitor object from which
     *   the _xArmDeflection, etc. are read when paint() is drawing the probes.
     */
    public ProbesCanvas (OrthoTweezersMonitor monitor) {
        super();
        
        _monitor = monitor;
    }
    
    /** Paint the probes on the canvas.  This is usually invoked when the
     * timer calls repaint().
     */
    public void paint (Graphics graphics) {
        // Calculate the center of the canvas.  Use the _size object which
        //   is already allocated to avoid allocating new memory every time.
        getSize(_size);
        int centerX = _size.width / 2;
        int centerY = _size.height / 2;

        // We want 0.5 millimeters of deflection to move 50 pixels on the canvas, so
        //  multiply by 100.
        Point probeXTip = new Point 
          (centerX + (int)((_monitor._xArmDeflection + _monitor._xTipDeflection) * 100.),
           centerY);
        Point probeYTip = new Point
          (centerX,
           centerY + (int)((_monitor._yArmDeflection + _monitor._yTipDeflection) * 100.));

        // Create temporary points.
        Point point1 = new Point();

        // Find the midpoint on the grip axis.
        Point axisMidpoint = new Point 
          ((probeXTip.x + probeYTip.x) / 2, (probeXTip.y + probeYTip.y) / 2);
        
        // Draw the grip axis
        graphics.setColor (Color.green);
        drawLineProper (graphics, probeXTip, probeYTip);
        // Draw a line orthogonal to the grip axis
        int deltaX = -(probeXTip.y - probeYTip.y) / 2;
        int deltaY = (probeXTip.x - probeYTip.x) / 2;
        point1.setLocation (axisMidpoint);
        point1.translate (deltaX, deltaY);
        drawLineProper (graphics, point1, axisMidpoint);
        point1.setLocation (axisMidpoint);
        point1.translate (-deltaX, -deltaY);
        drawLineProper (graphics, point1, axisMidpoint);

        // The total grip force is reflected across the line x=y, so the x component shows
        //   the force from probe Y and vice versa.  We want 10 millinewtons to be
        //   50 pixels, so multiply by 5.
        point1.setLocation (axisMidpoint);
        point1.translate ((int)(_monitor._yTipForce * 5.), (int)(_monitor._xTipForce * 5.));
        graphics.setColor (Color.red);
        drawLineProper (graphics, point1, axisMidpoint);
        // Draw individual lines of force for each probe. Negate the force so it is
        //   force on the object, not vice versa.
        point1.setLocation (probeXTip);
        point1.translate ((int)(- _monitor._xTipForce * 5.), 0);
        drawLineProper (graphics, point1, probeXTip);
        point1.setLocation (probeYTip);
        point1.translate (0, (int)(- _monitor._yTipForce * 5.));
        drawLineProper (graphics, point1, probeYTip);
        
        // Draw each probe
        graphics.setColor (Color.black);
        point1.setLocation (probeXTip.x, 0); 
        drawLineProper (graphics, point1, probeXTip);
        point1.setLocation (0, probeYTip.y);
        drawLineProper (graphics, point1, probeYTip);
    }
    
    /** Since larger screen coordinates are lower on the screen, but we want proper
     *  axes where they are higher on the screen so draw the line after inverting each point's Y
     *  as (_size.height - y).  Assume that _size has already been set to getSize (_size).
     *
     * @graphics    the Graphics context
     * @param point1    the beginning point of the line
     * @param point2    the end point of the line
     */
    private void drawLineProper (Graphics graphics, Point point1, Point point2) {
        graphics.drawLine (point1.x, _size.height - point1.y,
                           point2.x, _size.height - point2.y);
    }
    
    private OrthoTweezersMonitor _monitor;
    Dimension _size = new Dimension();
}
