/*
Copyright (c) 2000,2001. The Regents of the University of California
(Regents). All Rights Reserved.
 
Permission to use, copy, modify, and distribute this software and its
documentation for educational, research, and not-for-profit purposes,
without fee and without a signed licensing agreement, is hereby
granted, provided that the above copyright notice, this paragraph and
the following two paragraphs appear in all copies, modifications, and
distributions. Contact The Office of Technology Licensing, UC
Berkeley, 2150 Shattuck Avenue, Suite 510, Berkeley, CA 94720-1620,
(510) 643-7201, for commercial licensing opportunities.
 
IN NO EVENT SHALL REGENTS BE LIABLE TO ANY PARTY FOR DIRECT,
INDIRECT, SPECIAL, INCIDENTAL, OR CONSEQUENTIAL DAMAGES, INCLUDING
LOST PROFITS, ARISING OUT OF THE USE OF THIS SOFTWARE AND ITS
DOCUMENTATION, EVEN IF REGENTS HAS BEEN ADVISED OF THE POSSIBILITY OF
SUCH DAMAGE.
 
REGENTS SPECIFICALLY DISCLAIMS ANY WARRANTIES, INCLUDING, BUT NOT
LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR
A PARTICULAR PURPOSE. THE SOFTWARE AND ACCOMPANYING DOCUMENTATION, IF
ANY, PROVIDED HEREUNDER IS PROVIDED "AS IS". REGENTS HAS NO
OBLIGATION TO PROVIDE MAINTENANCE, SUPPORT, UPDATES, ENHANCEMENTS, OR
MODIFICATIONS.
 */

package orthotweezers;

/** SeekZSurface is a modal dialog box which calls OrthoTweezersTools.seekZSurface()
 * and provides a Cancel button to interrupt it.
 *
 * @author  unknown
 * @see OrthoTweezersTools#seekZSurface
 */
public class SeekZSurface extends ExecuteDialog {
    
    /** Creates new modal SeekZSurface dialog box.  
     *    The algorithm is run in a separate
     *    thread and the user can cancel.
     *
     * @param parent    The parent Frame
     * @param tools   The OrthoTweezersTools used to control the system.  
     */
    public SeekZSurface(java.awt.Frame parent, OrthoTweezersTools tools) {
        super (parent, "Seek Z Surface", "Seek",
        "Make sure probe X is clear and click Seek");
        _tools = tools;
    }
    
    /** This is called when the new thread is created to execute the procedure.
     */
    public void execute() throws CancelException {
        _tools.seekZSurface(2.);
        setStatus ("done");
    }
    
    private OrthoTweezersTools _tools;
}
