/*
 * YesNoCancelDialog.java
 *
 * Created on February 18, 2001, 5:57 PM
 */

package orthotweezers;

/** A YesNoCancelDialog presents a modal dialog box which displays the message
 * and allows the user to click Yes, No or Cancel.  
 *
 * @author  unknown
 */
public class YesNoCancelDialog extends javax.swing.JDialog {

    /** Creates new modal dialog box which displays the message
     * and allows the user to click Yes, No or Cancel.  You can get the
     * result by calling result().
     *
     * @param parent    the parent Frame
     * @param title     the title to put in the Dialog box title bar
     * @param message   the message to display in the dialog box
     */
    public YesNoCancelDialog(java.awt.Frame parent, String title, String message) {
        super (parent, true);
        initComponents ();
        setTitle (title);
        _message.setText(message);
    }

    /** This method is called from within the constructor to
     * initialize the form.
     * WARNING: Do NOT modify this code. The content of this method is
     * always regenerated by the FormEditor.
     */
    private void initComponents() {//GEN-BEGIN:initComponents
        yesButton = new javax.swing.JButton();
        noButton = new javax.swing.JButton();
        cancelButton = new javax.swing.JButton();
        _message = new javax.swing.JTextArea();
        getContentPane().setLayout(null);
        addWindowListener(new java.awt.event.WindowAdapter() {
            public void windowClosing(java.awt.event.WindowEvent evt) {
                closeDialog(evt);
            }
        }
        );
        
        yesButton.setText("Yes");
        yesButton.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                yesButtonActionPerformed(evt);
            }
        }
        );
        
        getContentPane().add(yesButton);
        yesButton.setBounds(20, 60, 60, 20);
        
        
        noButton.setText("No");
        noButton.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                noButtonActionPerformed(evt);
            }
        }
        );
        
        getContentPane().add(noButton);
        noButton.setBounds(90, 60, 60, 20);
        
        
        cancelButton.setText("Cancel");
        cancelButton.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                cancelButtonActionPerformed(evt);
            }
        }
        );
        
        getContentPane().add(cancelButton);
        cancelButton.setBounds(160, 60, 80, 20);
        
        
        _message.setLineWrap(true);
        _message.setEditable(false);
        _message.setBackground(new java.awt.Color (204, 204, 204));
        
        getContentPane().add(_message);
        _message.setBounds(10, 10, 250, 40);
        
        pack();
        java.awt.Dimension screenSize = java.awt.Toolkit.getDefaultToolkit().getScreenSize();
        java.awt.Dimension dialogSize = getSize();
        setSize(new java.awt.Dimension(300, 150));
        setLocation((screenSize.width-300)/2,(screenSize.height-150)/2);
    }//GEN-END:initComponents

  private void cancelButtonActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_cancelButtonActionPerformed
    _result = CANCEL;
    closeDialog(null);
  }//GEN-LAST:event_cancelButtonActionPerformed

  private void noButtonActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_noButtonActionPerformed
    _result = NO;
    closeDialog(null);
  }//GEN-LAST:event_noButtonActionPerformed

  private void yesButtonActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_yesButtonActionPerformed
    _result = YES;
    closeDialog(null);
  }//GEN-LAST:event_yesButtonActionPerformed

    /** Closes the dialog */
    private void closeDialog(java.awt.event.WindowEvent evt) {//GEN-FIRST:event_closeDialog
        // Note that if this is called because the user just clicks the close
        //   window button, that the result defaults to CANCEL.
        setVisible (false);
        dispose();
    }//GEN-LAST:event_closeDialog

  /** Return the result which is YES, NO or CANCEL.
   */
    public int result() {
        return _result;
    }
    
    // Variables declaration - do not modify//GEN-BEGIN:variables
    private javax.swing.JButton yesButton;
    private javax.swing.JButton noButton;
    private javax.swing.JButton cancelButton;
    private javax.swing.JTextArea _message;
    // End of variables declaration//GEN-END:variables

    private int _result = CANCEL;
    
    public final static int CANCEL = 0;
    public final static int YES = 1;
    public final static int NO = 2;

}
